

# BatchPutMessage
<a name="API_iotevents-data_BatchPutMessage"></a>

**Important**  
End of support notice: On May 20,2026, Amazon will end support for Amazon IoT Events. After May 20,2026, you will no longer be able to access the Amazon IoT Events console or Amazon IoT Events resources. For more information, see [Amazon IoT Events end of support](https://docs.amazonaws.cn/iotevents/latest/developerguide/iotevents-end-of-support.html). 

Sends a set of messages to the Amazon IoT Events system. Each message payload is transformed into the input you specify (`"inputName"`) and ingested into any detectors that monitor that input. If multiple messages are sent, the order in which the messages are processed isn't guaranteed. To guarantee ordering, you must send messages one at a time and wait for a successful response.

The following limits apply: 
+ Maximum messages per batch: 10
+ Maximum message payload per batch: 1024 Bytes (1 KiB)

## Request Syntax
<a name="API_iotevents-data_BatchPutMessage_RequestSyntax"></a>

```
POST /inputs/messages HTTP/1.1
Content-type: application/json

{
   "messages": [ 
      { 
         "inputName": "{{string}}",
         "messageId": "{{string}}",
         "payload": {{blob}},
         "timestamp": { 
            "timeInMillis": {{number}}
         }
      }
   ]
}
```

## URI Request Parameters
<a name="API_iotevents-data_BatchPutMessage_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_iotevents-data_BatchPutMessage_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [messages](#API_iotevents-data_BatchPutMessage_RequestSyntax) **   <a name="iotevents-iotevents-data_BatchPutMessage-request-messages"></a>
The list of messages to send. Each message has the following format: `'{ "messageId": "string", "inputName": "string", "payload": "string"}'`   
Type: Array of [Message](API_iotevents-data_Message.md) objects  
Array Members: Minimum number of 1 item.  
Required: Yes

## Response Syntax
<a name="API_iotevents-data_BatchPutMessage_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "BatchPutMessageErrorEntries": [ 
      { 
         "errorCode": "string",
         "errorMessage": "string",
         "messageId": "string"
      }
   ]
}
```

## Response Elements
<a name="API_iotevents-data_BatchPutMessage_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [BatchPutMessageErrorEntries](#API_iotevents-data_BatchPutMessage_ResponseSyntax) **   <a name="iotevents-iotevents-data_BatchPutMessage-response-BatchPutMessageErrorEntries"></a>
A list of any errors encountered when sending the messages.  
Type: Array of [BatchPutMessageErrorEntry](API_iotevents-data_BatchPutMessageErrorEntry.md) objects

## Errors
<a name="API_iotevents-data_BatchPutMessage_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalFailureException **   
An internal failure occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request was invalid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ServiceUnavailableException **   
The service is currently unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The request could not be completed due to throttling.    
 ** message **   
The message for the exception.
HTTP Status Code: 429

## See Also
<a name="API_iotevents-data_BatchPutMessage_SeeAlso"></a>

For more information about using this API in one of the language-specific Amazon SDKs, see the following:
+  [Amazon Command Line Interface V2](https://docs.amazonaws.cn/goto/cli2/iotevents-data-2018-10-23/BatchPutMessage) 
+  [Amazon SDK for .NET V4](https://docs.amazonaws.cn/goto/DotNetSDKV4/iotevents-data-2018-10-23/BatchPutMessage) 
+  [Amazon SDK for C\+\+](https://docs.amazonaws.cn/goto/SdkForCpp/iotevents-data-2018-10-23/BatchPutMessage) 
+  [Amazon SDK for Go v2](https://docs.amazonaws.cn/goto/SdkForGoV2/iotevents-data-2018-10-23/BatchPutMessage) 
+  [Amazon SDK for Java V2](https://docs.amazonaws.cn/goto/SdkForJavaV2/iotevents-data-2018-10-23/BatchPutMessage) 
+  [Amazon SDK for JavaScript V3](https://docs.amazonaws.cn/goto/SdkForJavaScriptV3/iotevents-data-2018-10-23/BatchPutMessage) 
+  [Amazon SDK for Kotlin](https://docs.amazonaws.cn/goto/SdkForKotlin/iotevents-data-2018-10-23/BatchPutMessage) 
+  [Amazon SDK for PHP V3](https://docs.amazonaws.cn/goto/SdkForPHPV3/iotevents-data-2018-10-23/BatchPutMessage) 
+  [Amazon SDK for Python](https://docs.amazonaws.cn/goto/boto3/iotevents-data-2018-10-23/BatchPutMessage) 
+  [Amazon SDK for Ruby V3](https://docs.amazonaws.cn/goto/SdkForRubyV3/iotevents-data-2018-10-23/BatchPutMessage) 